SystemOrganization addCategory: #'AardWorks-Gossip-Tests'!
SystemOrganization addCategory: #'AardWorks-Gossip'!

TestCase subclass: #AWGAntRouterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AardWorks-Gossip-Tests'!

!AWGAntRouterTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 21:09'!
testHopFor
	| ant id hop |
	ant _ AWGAntRouter new.
	id _ UUID new.
	ant receivedPacketFromUuid: id via: #(1 2 3 4) port: 1234.
	ant receivedPacketFromUuid: id via: #(5 6 7 8) port: 5678.
	ant receivedPacketFromUuid: id via: #(1 2 3 4) port: 1234.
	hop _ ant hopFor: id.
	self assert: (hop key = #(1 2 3 4)) | (hop key = #(5 6 7 8)).
	self assert: (hop value = 1234) | (hop value = 5678).	! !

!AWGAntRouterTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 21:02'!
testHostOverflow
	| ant id |
	ant _ AWGAntRouter new.
	id _ UUID new.
	1 to: AWGAntRouter hostListSize do: [:i |
		ant receivedPacketFromUuid: id via: #(1 2 3 4) port: 1234].
	self assert: ant peerTable size = 1.
	self assert: (ant peerTable at: id) size = AWGAntRouter hostListSize.
	ant receivedPacketFromUuid: id via: #(5 6 7 8) port: 5678.
	self assert: (ant peerTable at: id) size = AWGAntRouter hostListSize.

	1 to: AWGAntRouter hostListSize - 1 do: [:i |
		self assert: ((ant peerTable at: id) at: i) key = #(1 2 3 4).
		self assert: ((ant peerTable at: id) at: i) value = 1234].
	self assert: (ant peerTable at: id) last key = #(5 6 7 8).
	self assert: (ant peerTable at: id) last value = 5678.! !

!AWGAntRouterTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 21:06'!
testPeerOverflow
	| ant id1 id2 |
	ant _ AWGAntRouter new.
	id1 _ UUID new.
	ant receivedPacketFromUuid: id1 via: #(1 2 3 4) port: 1234.
	1 to: AWGAntRouter peerListSize - 1 do: [:i |
		ant receivedPacketFromUuid: UUID new via: #(4 5 6 7) port: 4567].
	self assert: ant peerTable size = AWGAntRouter peerListSize.
	id2 _ UUID new.
	ant receivedPacketFromUuid: id2 via: #(9 8 7 6) port: 9876.
	self assert: ant peerTable size = AWGAntRouter peerListSize.

	self deny: (ant peerTable includesKey: id1).
	self assert: (ant peerTable includesKey: id2).! !

!AWGAntRouterTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 20:54'!
testReceivePacket1
	| ant id |
	ant _ AWGAntRouter new.
	id _ UUID new.
	ant receivedPacketFromUuid: id via: #(1 2 3 4) port: 1234.
	self assert: ant peerTable size = 1.
	self assert: (ant peerTable includesKey: id).
	self assert: (ant peerTable at: id) size = 1.
	self assert: (ant peerTable at: id) first key = #(1 2 3 4).
	self assert: (ant peerTable at: id) first value = 1234.! !

!AWGAntRouterTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 20:55'!
testReceivePacket2
	| ant id |
	ant _ AWGAntRouter new.
	id _ UUID new.
	ant receivedPacketFromUuid: id via: #(1 2 3 4) port: 1234.
	ant receivedPacketFromUuid: id via: #(5 6 7 8) port: 5678.
	self assert: ant peerTable size = 1.
	self assert: (ant peerTable includesKey: id).
	self assert: (ant peerTable at: id) size = 2.
	self assert: (ant peerTable at: id) first key = #(1 2 3 4).
	self assert: (ant peerTable at: id) first value = 1234.
	self assert: (ant peerTable at: id) second key = #(5 6 7 8).
	self assert: (ant peerTable at: id) second value = 5678.! !

TestCase subclass: #AWGPeerListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AardWorks-Gossip-Tests'!

!AWGPeerListTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 22:43'!
testMarshallEntry
	| e1 e2 |
	e1 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(1 2 3 4);
				observedPort: 1234;
				claimedAddress: #(4 5 6 7);
				claimedPort: 45670;
				hopCount: 3.
	e2 := AWGPeerListEntry fromByteArray: e1 asByteArray.
	
	self assert: e1 peerId = e2 peerId.
	self assert: e1 observedAddress = e2 observedAddress.
	self assert: e1 observedPort = e2 observedPort.
	self assert: e1 claimedAddress = e2 claimedAddress.
	self assert: e1 claimedPort = e2 claimedPort.
	self assert: e1 hopCount = e2 hopCount! !

!AWGPeerListTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/22/2005 11:16'!
testMarshallList
	| e1 e2 l id1 id2 |
	e1 := (AWGPeerListEntry new)
				peerId: (id1 _ UUID new);
				observedAddress: #(1 2 3 4);
				observedPort: 1234;
				claimedAddress: #(4 5 6 7);
				claimedPort: 4567;
				hopCount: 5.
	e2 := (AWGPeerListEntry new)
				peerId: (id2 _ UUID new);
				observedAddress: #(9 8 7 6);
				observedPort: 9876;
				claimedAddress: #(5 4 3 2);
				claimedPort: 5432;
				hopCount: 10.
	self assert: id1 ~= id2.
	l _ AWGPeerList new. l add: e1; add: e2.
	
	l := AWGPeerList fromByteArray: l asByteArray.
	self assert: l size = 2.
	
	self assert: (l at: 1) peerId = e1 peerId.
	self assert: (l at: 1) observedAddress = e1 observedAddress.
	self assert: (l at: 1) observedPort = e1 observedPort.
	self assert: (l at: 1) claimedAddress = e1 claimedAddress.
	self assert: (l at: 1) claimedPort = e1 claimedPort.
	self assert: (l at: 1) hopCount = e1 hopCount.
	
	self assert: (l at: 2) peerId = e2 peerId.
	self assert: (l at: 2) observedAddress = e2 observedAddress.
	self assert: (l at: 2) observedPort = e2 observedPort.
	self assert: (l at: 2) claimedAddress = e2 claimedAddress.
	self assert: (l at: 2) claimedPort = e2 claimedPort.
	self assert: (l at: 2) hopCount = e2 hopCount! !

!AWGPeerListTest methodsFor: 'as yet unclassified' stamp: 'CdG,TJ 2/16/2005 21:20'!
testMergeDuplicate
	| e1 e2 l |
	e1 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(1 2 3 4);
				observedPort: 1234;
				claimedAddress: #(4 5 6 7);
				claimedPort: 4567;
				hopCount: 3.
	e2 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(9 8 7 6);
				observedPort: 9876;
				claimedAddress: #(4 5 6 7);
				claimedPort: 4567;
				hopCount: 3.
	l := AWGPeerList new.
	l maxSize: 1.
	l add: e1.
	l add: e2.
	self assert: l size = 1.
	"updated with last observation? we can't test it, it's done stochastically"! !

!AWGPeerListTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 22:54'!
testMerging
	| e1 e2 l |
	e1 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(1 2 3 4);
				hopCount: 3.
	e2 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(3 4 5 6);
				hopCount: 1.
	l := AWGPeerList new.
	l maxSize: 1.
	l add: e1.
	l add: e2.
	self assert: l size = 1.
	"lowest hopcount won the merge"
	self assert: (l at: 1) observedAddress = #(3 4 5 6)! !

!AWGPeerListTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 22:55'!
testOrdering
	| e1 e2 l |
	e1 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(1 2 3 4);
				hopCount: 3.
	e2 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(3 4 5 6);
				hopCount: 1.
	l := AWGPeerList new.
	l add: e1.
	l add: e2.
	self assert: l size = 2.
	self assert: (l at: 1) observedAddress = #(3 4 5 6)! !

!AWGPeerListTest methodsFor: 'as yet unclassified' stamp: 'CdG,TJ 2/16/2005 21:22'!
testRandomPeer
	| e1 e2 l e |
	e1 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(1 2 3 4);
				observedPort: 1234;
				claimedAddress: #(4 5 6 7);
				claimedPort: 4567;
				hopCount: 3.
	e2 := (AWGPeerListEntry new)
				peerId: UUID new;
				observedAddress: #(9 8 7 6);
				observedPort: 9876;
				claimedAddress: #(4 5 6 7);
				claimedPort: 4567;
				hopCount: 3.
	l _ AWGPeerList new.
	l add: e1; add: e2.
	
	e _ l randomPeer.
	self assert: e notNil.
	self assert: (e peerId = e2 peerId) | (e peerId = e1 peerId) "duh..." ! !

TestCase subclass: #AWGPeerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AardWorks-Gossip-Tests'!

!AWGPeerTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 21:19'!
testDisassembly
	| peer data source dest id |
	peer _ AWGPeer new.
	data _ ByteArray withAll: (source _ UUID new), (dest _ UUID new), (id _ UUID new), (ByteArray new: 1), #(2 3 5 8 13) asByteArray.
	self assert: (peer sourceIdFrom: data) = source.
	self assert: (peer targetIdFrom: data) = dest.
	self assert: (peer packetIdFrom: data) = id.
	self assert: (data at: peer hopCountPosition) = 0.
	self assert: (peer dataFrom: data) = #(2 3 5 8 13) asByteArray! !

!AWGPeerTest methodsFor: 'as yet unclassified' stamp: 'CdG 2/21/2005 21:23'!
testHopCountLimiter
	| peer data |
	peer _ AWGPeer new.
	data _ ByteArray withAll: UUID new, UUID new, UUID new, (ByteArray new: 1), 
							#(2 3 5 8 13) asByteArray.
	1 to: AWGPeer timeToLive - 1 do: [:i |
		self deny: (peer hopCountLimiter: data)].
	self assert: (peer hopCountLimiter: data)! !

Object subclass: #AWGAntRouter
	instanceVariableNames: 'peerTable peerList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AardWorks-Gossip'!

!AWGAntRouter commentStamp: 'CdG,TJ 2/17/2005 00:30' prior: 0!
This class implements 'ant routing'. Every packet leaves a 'pheromone trail' when traversing the network. The ant router notices this by looking what hosts sent us packets from what peers (host = IP address, peer = UUID). The last n packets from a peer, coming from m different hosts, form a distribution. When routing a packet to a peer, one of the m hosts is picked at random according to the weighted distribution.!

!AWGAntRouter class methodsFor: 'accessing' stamp: 'CdG,TJ 2/17/2005 00:47'!
hostListSize
	"the number of host entries per peer we keep information on"
	^20! !

!AWGAntRouter class methodsFor: 'accessing' stamp: 'CdG,TJ 2/17/2005 00:46'!
peerListSize
	"the number of peers we keep information on"
	^100! !

!AWGAntRouter methodsFor: 'api' stamp: 'CdG,TJ 2/17/2005 00:48'!
hopFor: aUUID
	| hosts |
	hosts _ self peerTable at: aUUID ifAbsent: [^nil].
	^hosts atRandom! !

!AWGAntRouter methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:46'!
peerList
	^peerList ifNil: [peerList _ OrderedCollection new]! !

!AWGAntRouter methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:45'!
peerTable
	^peerTable ifNil: [peerTable _ Dictionary new]! !

!AWGAntRouter methodsFor: 'api' stamp: 'CdG 2/21/2005 21:05'!
receivedPacketFromUuid: aUUID via: host port: port
	"note that we received a packet from a peer through a certain host/port"
	| list toRemove |
	list _ self peerTable at: aUUID ifAbsent: nil.
	list = nil ifTrue: [
		"new peer - add it"
		self peerList add: aUUID.
		self peerList size > self class peerListSize ifTrue: [
			"overflow - shrink"
			toRemove _ self peerList removeFirst.
			self peerTable removeKey: toRemove].
		self peerTable at: aUUID put: (list _ OrderedCollection new)].
	
	list add: host->port.
	list size > self class hostListSize ifTrue: [
		list removeFirst].
	
	! !

Object subclass: #AWGPeer
	instanceVariableNames: 'channel peerList peerId duplicationList antRouter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AardWorks-Gossip'!

!AWGPeer commentStamp: 'CdG,TJ 2/17/2005 00:24' prior: 0!
This is the nexus of the peer-to-peer system. Its interface operates purely in terms of uuid's for peer addresses - you send data to and from certain endpoints to and from certain peers; routing is taken care of on a lower level. 

Routing can be done in three ways, in order of preference:
- If the peer's peer list contains the peer, route directly;
- If the peer's ant routing cache contains the peer, route through one of the recent hosts;
- If the peer is unknown, send to all connected peers with a TTL.

A peer is associated with a channel through which all traffic is pumped. 

All data is sent out in the format:
- source UUID - 16 bytes (pos 1-16)
- target UUID - 16 bytes (pos 17-32)
- packet UUID - 16 bytes (pos 33-48)
- hopCount - 1 byte (pos 49)
- data (pos 50-...)
The target endpoint is in the outer encapsulation - we simply reuse that, so no need to put it in the packet again.

These offsets are all collected in the 'private-disassembling' protocol, no need to change them in any other place.!

!AWGPeer class methodsFor: 'accessing' stamp: 'CdG,TJ 2/17/2005 00:26'!
duplicationListSize
	"the maximum number of uuid's we keep around for checking for duplicates"
	^1000! !

!AWGPeer class methodsFor: 'instance creation' stamp: 'CdG 2/21/2005 22:21'!
newOnUDPPort: aSmallInteger
	| chan |
	chan _ TUDispatchingDatagramChannel onUDPPort: aSmallInteger.
	chan start.
	^self new startOn: chan.! !

!AWGPeer class methodsFor: 'accessing' stamp: 'CdG,TJ 2/17/2005 00:06'!
timeToLive
	"Answers the number of hops we want to route packets"
	^7! !

!AWGPeer methodsFor: 'accessing' stamp: 'CdG 2/21/2005 23:10'!
addPeer: aUUID host: host port: port
	"for seeding the cache. we add these with very high hopcount so that they'll hopefully be 
	 flushed quickly by real data"
	| entry |
	entry _ AWGPeerListEntry new
		peerId: aUUID;
		observedAddress: host;
		observedPort: port;
		claimedAddress: host;
		claimedPort: port;
		hopCount: AWGPeerList maxHopCount.
	self peerList add: entry.! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:26'!
antRouter
	^antRouter ifNil: [antRouter _ AWGAntRouter new]! !

!AWGPeer methodsFor: 'private-disassembling' stamp: 'CdG,TJ 2/17/2005 00:22'!
dataFrom: aByteArray 
	^aByteArray copyFrom: 50 to: aByteArray size! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:02'!
dispatch: aByteArray toHost: peer onEndPoint: aSmallInteger reliable: aBoolean 
	| datagram |
	datagram := TUDatagram newReliable: aBoolean.
	datagram
		endPoint: aSmallInteger;
		host: peer observedAddress;
		port: peer observedPort;
		data: aByteArray.
	channel send: datagram! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:22'!
dispatchDatagram: datagram possiblyTo: somethingThatRespondsToValueWith 
	"It may very well be that we receive datagrams for a locally registered endpoint, but
	 of course that only is valid if it is to be delivered locally. If not, route it on"

	| sourceUuid observedHost observedPort targetUuid data packetId |
	packetId := self packetIdFrom: datagram data.
	(self duplicationPrevention: packetId) 
		ifTrue: [^self	"been there, done that"].
	sourceUuid := self sourceIdFrom: datagram data.
	observedHost := datagram host.
	observedPort := datagram port.
	self antRouter 
		receivedPacketFromUuid: sourceUuid
		via: observedHost
		port: observedPort.
	targetUuid := self targetIdFrom: datagram data.
	targetUuid = peerId 
		ifTrue: 
			["yes - process is locally"

			data := self dataFrom: datagram data.
			somethingThatRespondsToValueWith value: data value: sourceUuid]
		ifFalse: 
			["no - pass it on"

			self 
				routeData: datagram data
				toPeer: targetUuid
				onEndPoint: datagram endPoint
				reliable: datagram isReliable]! !

!AWGPeer methodsFor: 'sending-receiving' stamp: 'CdG,TJ 2/16/2005 23:51'!
dispatchDynamicEndPointTo: somethingThatRespondsToValueWith
	"register a callback block for a dynamically allocated endpoint. The block will be called as
		[:data :sourceUuid | ....]
	"
	^channel dispatchDynamicEndPointTo: [:datagram |
		self dispatchDatagram: datagram possiblyTo: somethingThatRespondsToValueWith]! !

!AWGPeer methodsFor: 'sending-receiving' stamp: 'CdG,TJ 2/16/2005 23:51'!
dispatchEndPoint: aSmallInteger to: somethingThatRespondsToValueWith
	"register a callback block for the indicated endpoint. The block will be called as
		[:data :sourceUuid | ....]
	"
	^channel dispatchEndPoint: aSmallInteger to: [:datagram |
		self dispatchDatagram: datagram possiblyTo: somethingThatRespondsToValueWith]! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:43'!
duplicationList
	"we maybe want to have a linked list here, or something even more complex
	 but better optimized (combination of a list and a set, probably)"
	^duplicationList ifNil: [duplicationList _ OrderedCollection new]! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:19'!
duplicationPrevention: aUUID
	(self duplicationList includes: aUUID) ifTrue: [^true].
	self duplicationList add: aUUID.
	self duplicationList size > self class duplicationListSize ifTrue: [
		self duplicationList removeFirst].
	^false! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:23'!
hopCountLimiter: aByteArray
	| hopCount |
	hopCount _ aByteArray unsignedByteAt: self hopCountPosition.
	hopCount _ hopCount + 1.
	hopCount >= self class timeToLive ifTrue: [^true].
	aByteArray unsignedByteAt: self hopCountPosition put: hopCount.
	^false! !

!AWGPeer methodsFor: 'private-disassembling' stamp: 'CdG,TJ 2/17/2005 00:23'!
hopCountPosition
	^49! !

!AWGPeer methodsFor: 'initialize-release' stamp: 'CdG,TJ 2/16/2005 23:19'!
initialize
	peerId _ UUID new! !

!AWGPeer methodsFor: 'private-disassembling' stamp: 'CdG,TJ 2/17/2005 00:22'!
packetIdFrom: aByteArray 
	^UUID newFrom: (aByteArray copyFrom: 33 to: 48)! !

!AWGPeer methodsFor: 'accessing' stamp: 'CdG 2/21/2005 21:56'!
peerId
	^peerId! !

!AWGPeer methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 23:19'!
peerId: aUUID
	peerId _ aUUID! !

!AWGPeer methodsFor: 'accessing' stamp: 'CdG 2/21/2005 21:44'!
peerList
	^peerList! !

!AWGPeer methodsFor: 'accessing' stamp: 'CdG 2/21/2005 21:57'!
port
	^channel port! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/16/2005 23:56'!
routeAnt: aByteArray toPeer: aUUID onEndPoint: aSmallInteger reliable: aBoolean
	| hop datagram |
	hop _ self antRouter hopFor: aUUID.
	hop ifNil: [^false].
	datagram _ TUDatagram newReliable: aBoolean.
	datagram
		endPoint: aSmallInteger;
		host: hop key;
		port: hop value;
		data: aByteArray.
	channel send: datagram.
	^true! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:03'!
routeBroadcast: aByteArray toPeer: aUUID  onEndPoint: aSmallInteger reliable: aBoolean
	"always successful..."
	peerList entries do: [:each |
		self
			dispatch: aByteArray
			toHost: each
			onEndPoint: aSmallInteger
			reliable: aBoolean].
	^true! !

!AWGPeer methodsFor: 'private' stamp: 'CdG,TJ 2/17/2005 00:19'!
routeData: aByteArray toPeer: aUUID onEndPoint: aSmallInteger reliable: aBoolean
	(self hopCountLimiter: aByteArray) ifTrue: [^self "sorry, too old"].
	"note that data at this point is a (source,target,payload) block cf. the class comment"
	(self routeDirect: aByteArray toPeer: aUUID onEndPoint: aSmallInteger reliable: aBoolean) ifTrue: [^self].
	(self routeAnt: aByteArray toPeer: aUUID  onEndPoint: aSmallInteger reliable: aBoolean) ifTrue: [^self].
	self routeBroadcast: aByteArray toPeer: aUUID  onEndPoint: aSmallInteger reliable: aBoolean.! !

!AWGPeer methodsFor: 'private' stamp: 'CdG 2/21/2005 21:24'!
routeDirect: aByteArray toPeer: aUUID onEndPoint: aSmallInteger reliable: aBoolean 
	| peer |
	peer := peerList peerAt: aUUID.
	peer ifNil: [^false].
	
	self 
		dispatch: aByteArray
		toHost: peer
		onEndPoint: aSmallInteger
		reliable: aBoolean.
	^true! !

!AWGPeer methodsFor: 'sending-receiving' stamp: 'CdG 2/21/2005 21:19'!
send: aByteArray toPeer: aUUID onEndPoint: aSmallInteger reliable: aBoolean
	| data |
	data _ ByteArray withAll: (peerId, aUUID, UUID new, (ByteArray new: 1), aByteArray).
	self routeData: data toPeer: aUUID onEndPoint: aSmallInteger reliable: aBoolean! !

!AWGPeer methodsFor: 'initialize-release' stamp: 'CdG 2/21/2005 21:36'!
shutdown
	peerList ifNotNil: [peerList stop].
	channel ifNotNil: [channel shutdown]! !

!AWGPeer methodsFor: 'private-disassembling' stamp: 'CdG,TJ 2/17/2005 00:23'!
sourceIdFrom: aByteArray 
	^UUID newFrom: (aByteArray copyFrom: 1 to: 16)! !

!AWGPeer methodsFor: 'initialize-release' stamp: 'CdG 2/21/2005 23:18'!
startOn: aTUDispatchingDatagramChannel
	channel _ aTUDispatchingDatagramChannel.
	peerList _ AWGPeerList new peer: self; startOn: channel.
	channel dispatchEverythingElseTo: [:datagram |
		self dispatchDatagram: datagram possiblyTo: [:data :source | ]]
! !

!AWGPeer methodsFor: 'initialize-release' stamp: 'CdG 2/21/2005 21:35'!
stop
	peerList ifNotNil: [peerList stop].
	channel ifNotNil: [channel stop]! !

!AWGPeer methodsFor: 'private-disassembling' stamp: 'CdG,TJ 2/17/2005 00:23'!
targetIdFrom: aByteArray 
	^UUID newFrom: (aByteArray copyFrom: 17 to: 32)! !

!AWGPeer methodsFor: 'sending-receiving' stamp: 'CdG,TJ 2/17/2005 01:44'!
unRegisterEndPoint: aSmallInteger
	channel unRegisterEndPoint: aSmallInteger! !

Object subclass: #AWGPeerList
	instanceVariableNames: 'peer entries maxSize channel talkerProcess myReplyEndPoint'
	classVariableNames: 'SleepTime'
	poolDictionaries: ''
	category: 'AardWorks-Gossip'!

!AWGPeerList class methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:58'!
defaultMaxSize
	^30! !

!AWGPeerList class methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 22:28'!
defaultSleepTime
	^5000 "ms"! !

!AWGPeerList class methodsFor: 'instance creation' stamp: 'CdG 2/21/2005 23:20'!
fromByteArray: aByteArray
	| size answer offset bytes |
	size _ aByteArray at: 1.
	answer _ self new.
	offset _ 2.
	1 to: size do: [:i |
		bytes _ aByteArray copyFrom: offset to: offset + AWGPeerListEntry marshalledSize - 1.
		answer add: (AWGPeerListEntry fromByteArray: bytes).
		offset _ offset + AWGPeerListEntry marshalledSize].
	^answer! !

!AWGPeerList class methodsFor: 'accessing' stamp: 'CdG 2/21/2005 23:04'!
maxHopCount
	^50 "we're really not interested in anything further away than this"! !

!AWGPeerList class methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 22:28'!
sleepTime
	"every 'sleepTime' milliseconds, the peerlist exchanges views"
	^SleepTime ifNil: [SleepTime _ self defaultSleepTime]! !

!AWGPeerList class methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 22:30'!
wellKnownEndPoint
	^1! !

!AWGPeerList methodsFor: 'adding - merging' stamp: 'CdG 2/22/2005 11:05'!
add: anAWGHostListEntry
	| duplicate |
	anAWGHostListEntry hopCount > self class maxHopCount ifTrue: [^self].
	peer ifNotNil: [
		"junk entries pointing to us, whether they've got the correct ID or not"
		anAWGHostListEntry peerId = peer peerId ifTrue: [^self].
		((anAWGHostListEntry claimedAddress asByteArray = NetNameResolver localHostAddress asByteArray)
			& (anAWGHostListEntry claimedPort = peer port))
			ifTrue: [^self]].

	duplicate _ self entryFor: anAWGHostListEntry.
	duplicate ifNotNil: [^duplicate updateFrom: anAWGHostListEntry].
	self entries size < self maxSize ifTrue: [^self entries add: anAWGHostListEntry].
	
	"when merging, keep the lowest hopcount but prefer entries from the other side - this
      helps in flushing stale stuff (I hope :P)"
	(self entries last hopCount >= anAWGHostListEntry hopCount)
		ifTrue: [
			self entries 
				removeAt: self entries size;
				add: anAWGHostListEntry]! !

!AWGPeerList methodsFor: 'converting' stamp: 'CdG,TJ 2/16/2005 22:07'!
asByteArray
	| strm |
	strm _ WriteStream on: (ByteArray new: self entries size * AWGPeerListEntry marshalledSize).
	strm nextPut: self entries size.
	self entries do: [:each |
		strm nextPutAll: each asByteArray].
	^strm contents! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:49'!
at: aNumber
	^entries at: aNumber ifAbsent: nil! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:50'!
entries
	^entries ifNil: [entries _ SortedCollection 
		sortBlock: [:a :b | a hopCount < b hopCount]]! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG 2/21/2005 22:24'!
entries: anObject
	entries _ anObject! !

!AWGPeerList methodsFor: 'private' stamp: 'CdG 2/21/2005 23:27'!
entryFor: anAWGHostListEntry 
	^self entries 
		detect: [:each | (each peerId = anAWGHostListEntry peerId) or: [
			each observedAddress = anAWGHostListEntry observedAddress and: [
			each observedPort = anAWGHostListEntry observedPort]]]
		ifNone: nil! !

!AWGPeerList methodsFor: 'private' stamp: 'CdG 2/21/2005 23:35'!
handleReceivedDatagram: datagram doReply: aBoolean
	"we received a datagram. Pick out the data we need, merge the view, and answer some
	 stuff that's needed to send a reply, if necessary"

	| replyPort list sender | 
	replyPort := datagram data unsignedShortAt: 1 bigEndian: true.
	list := self class 
				fromByteArray: (datagram data copyFrom: 3 to: datagram data size).
	"if we need to reply, send the current list before merging"
	sender _ list entries first.
	sender
		observedAddress: datagram host;
		observedPort: datagram port.
	aBoolean ifTrue: [
		self sendViewTo: sender endPoint: replyPort replyTo: 0 "enough is enough ;)"].
	^self handleReceivedList: list replyTo: 0.! !

!AWGPeerList methodsFor: 'private' stamp: 'CdG 2/22/2005 00:03'!
handleReceivedList: list replyTo: replyPort 
	list entries do: [:each | 
		each hopCount: each hopCount + 1.
		self add: each].
! !

!AWGPeerList methodsFor: 'initialize-release' stamp: 'CdG,TJ 2/16/2005 20:58'!
initialize
	super initialize.
	maxSize _ self class defaultMaxSize! !

!AWGPeerList methodsFor: 'private' stamp: 'CdG,TJ 2/16/2005 22:53'!
listenerBlock
	"this block listens to unsollicited incoming lists."
	^[:datagram |
		self handleReceivedDatagram: datagram doReply: true]! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:02'!
maxSize
	^maxSize! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:58'!
maxSize: anObject
	maxSize _ anObject! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG 2/21/2005 21:52'!
peer: anAWGPeer
	peer _ anAWGPeer! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:22'!
randomPeer
	^self entries atRandom! !

!AWGPeerList methodsFor: 'private' stamp: 'CdG,TJ 2/16/2005 22:53'!
replyListenerBlock
	"this block listens to sollicited replies - all we need to do is merge the view"
	^[:datagram |
		self handleReceivedDatagram: datagram doReply: false]! !

!AWGPeerList methodsFor: 'private' stamp: 'CdG 2/21/2005 23:24'!
sendViewTo: anAWGPeerListEntry endPoint: targetEndPoint replyTo: replyToEndPointOrZero 
	"we sent to the observed host"

	| sendList data datagram | 
	sendList := self class new entries: entries copy.
	sendList add: (AWGPeerListEntry new
		peerId: peer peerId;
		observedAddress: NetNameResolver localHostAddress;
		observedPort: peer port;
		claimedAddress: NetNameResolver localHostAddress;
		claimedPort: peer port;
		hopCount: 0).
	data := (ByteArray with: 0 with: 0) , sendList asByteArray.
	data unsignedShortAt: 1 put: replyToEndPointOrZero bigEndian: true.
	datagram := (TUDatagram new)
				endPoint: targetEndPoint;
				host: anAWGPeerListEntry observedAddress;
				port: anAWGPeerListEntry observedPort;
				data: data.
	channel send: datagram! !

!AWGPeerList methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:50'!
size
	^self entries size! !

!AWGPeerList methodsFor: 'initialize-release' stamp: 'CdG 2/21/2005 22:11'!
startOn: aTUDispatchingDatagramChannel 
	channel := aTUDispatchingDatagramChannel.
	channel dispatchEndPoint: self class wellKnownEndPoint
		to: self listenerBlock.
	myReplyEndPoint := channel 
				dispatchDynamicEndPointTo: self replyListenerBlock.
	talkerProcess := 	[[self talkerBody] repeat] fork! !

!AWGPeerList methodsFor: 'initialize-release' stamp: 'CdG,TJ 2/16/2005 22:37'!
stop
	talkerProcess ifNotNil: [talkerProcess terminate. talkerProcess _ nil].
	channel ifNotNil: [
		channel unRegisterEndPoint: self class wellKnownEndPoint.
		channel unRegisterEndPoint: replyEndPoint].! !

!AWGPeerList methodsFor: 'private' stamp: 'CdG 2/21/2005 22:11'!
talkerBody
	(Delay forMilliseconds: self class sleepTime) wait.
	^self size > 0 
		ifTrue: 
			[self 
				sendViewTo: self randomPeer
				endPoint: self class wellKnownEndPoint
				replyTo: myReplyEndPoint]! !

Object subclass: #AWGPeerListEntry
	instanceVariableNames: 'peerId claimedAddress claimedPort observedAddress observedPort hopCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AardWorks-Gossip'!

!AWGPeerListEntry class methodsFor: 'instance creation' stamp: 'CdG 2/21/2005 22:49'!
fromByteArray: aByteArray
	"goes hand-in-hand with #fromByteArray: at the class side"
	| answer |
	answer _ self new.
	answer 
		peerId: (UUID newFrom: (aByteArray copyFrom: 1 to: 16));
		observedAddress: (aByteArray copyFrom: 17 to: 20) asArray;
		observedPort: (aByteArray unsignedShortAt: 21 bigEndian: true);
		claimedAddress: (aByteArray copyFrom: 23 to: 26) asArray;
		claimedPort: (aByteArray unsignedShortAt: 27 bigEndian: true);
		hopCount: (aByteArray unsignedByteAt: 29).
	^answer! !

!AWGPeerListEntry class methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:53'!
marshalledSize
	"see #fromByteArray:"
	^29! !

!AWGPeerListEntry methodsFor: 'converting' stamp: 'CdG 2/21/2005 22:50'!
asByteArray
	"goes hand-in-hand with #fromByteArray: at the class side"
	| answer |
	answer _ ByteArray new: 29.
	answer 
		replaceFrom: 1 to: 16 with: peerId startingAt: 1;
		replaceFrom: 17 to: 20 with: observedAddress startingAt: 1;
		unsignedShortAt: 21 put: observedPort bigEndian: true;
		replaceFrom: 23 to: 26 with: claimedAddress startingAt: 1;
		unsignedShortAt: 27 put: claimedPort bigEndian: true;
		unsignedByteAt: 29 put: hopCount.
	^answer! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:19'!
claimedAddress
	^claimedAddress! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:08'!
claimedAddress: anObject
	claimedAddress _ anObject! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:19'!
claimedPort
	^claimedPort! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:08'!
claimedPort: anObject
	claimedPort _ anObject! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:50'!
hopCount
	^hopCount! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:47'!
hopCount: anObject
	hopCount _ anObject! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:50'!
observedAddress
	^observedAddress! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 20:47'!
observedAddress: anObject
	observedAddress _ anObject! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:19'!
observedPort
	^observedPort! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:08'!
observedPort: anObject
	observedPort _ anObject! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:19'!
peerId
	^peerId! !

!AWGPeerListEntry methodsFor: 'accessing' stamp: 'CdG,TJ 2/16/2005 21:14'!
peerId: anObject
	peerId _ anObject! !

!AWGPeerListEntry methodsFor: 'updating' stamp: 'CdG 2/21/2005 23:48'!
updateFrom: anAWGPeerListEntry 
	anAWGPeerListEntry hopCount <= hopCount ifTrue: [
		peerId _ anAWGPeerListEntry peerId.
		observedAddress _ anAWGPeerListEntry observedAddress.
		observedPort _ anAWGPeerListEntry observedPort.
		claimedAddress _ anAWGPeerListEntry claimedAddress.
		claimedPort _ anAWGPeerListEntry claimedPort.
		hopCount _ anAWGPeerListEntry hopCount]
	
! !

Object subclass: #AardWorks-Gossip
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AardWorks-Gossip'!

!AardWorks-Gossip commentStamp: 'CdG,TJ 2/17/2005 01:53' prior: 0!
This is a 'gossiping' peer-to-peer kernel based on the Tric-Datagram Toolkit package (it is a prerequisite, if you loaded this from Monticello it should be in your image now).

The nexus if AWGPeer. You start it on a TUDispatchingDatagramChannel with #startOn: (or anything else that responds to #send: and the dispatch registration methods in there; network simulation code to follow ;)). It is also nice to bootstrap it with some known peers, obtained from wherever you usually obtain your bootstrap peers, by sending #addPeer:host:port: for any peers you happen to know (note that you probably don't need to fill in valid uuid's for the seed list, but it helps. Something to be evaluated).

The end-user idea of an AWGPeer is that you can exchange messages with other peers much like through a TUDispatchingDatagramChannel, however you don't work with IP host/port addresses, but with peer UUID's. AWGPeer and its friends take care of attempting to get stuff at the right location, but that's all a black box (well, after the initial seeding that is). 

The machine that goes ticking has a couple of recognizable components:

AWGPeerList builds a cache of known, directly-reachable peers. Basically a mapping of UUID's to host/port pairs, with a hopcount and for good measure its helper class, AWGPeerListEntry, keeps track of both advertised and observed addresses in order to be able to deal with NAT situations (not much done with that at the moment - traffic always goes to the observed addresses, but it may help later on in telling the nodes that they're behind NAT or whatever. It's cool and it doesn't hurt, ok?). A process selects a peer at random and exchanges peer lists with that node. The algorithm can be found in " Gossip-based Unstructured Overlay Networks:
An Experimental Evaluation" by Jelasity, Guerraoui, Kermarrec, van Steen (University of Bolgna, 2003, http://www.cs.vu.nl/pub/steen/papers/wip-gossip.pdf) but may change without notice (and especially without updating these comments ;)). The idea is that this builds an unstructured overlay network that has the right properties to behave stable over time with peers joining and leaving all the time. AWGPeerList describes the basic network (well, all instances of AWGPeerList in the network, that is). 

AWGPeer handles reception and transmission of packets and also offers the user interface. You can send (#send:toPeer:onEndPoint:reliable:) and register for reception (#dispatchEndPoint:to: and #dispatchDynamicEndPointTo:), all based on peer UUID's. Broadcasting will be dealt with too (through a special, network-wide-known, broadcast UUID, probably). 

Packets that come in for the local peer are either sent to a handler or dropped (in case there's nobody around anymore to deal with them). Packets that are not for the local host (wether they originate locally or came in from the network) are routed, roughly the following algorithm:
- check whether the packet has a known uuid. If yes, drop it as a duplicate. If no, note the uuid for duplicate detection.
- increase the hop count and check it against the maximum TTL. drop if too many hops.
- ask AWGPeerList whether there's an entry for the peer. If yes, send it off directly.
- ask AWGAntRouter whether there's an entry for the peer. If yes, send it off to a random host that sent us packets from that peer (look at AWGAntRouter for details).
- if both of these fail, send the packet to all peers that AWGPeerList knows and hope for the best (broadcast routing).

Every node tries to do the same, with the hopeful end result that the packet lands at its destination. 

Some notes:
- Reliability is on the network level only. I.e. once a routing decision has been taken, that's it. This is bad, because if a packet cannot be transmitted to the destination via one route, another one should be tried. For this, the lower levels need to be able to signal the higher levels if delivery failed. To be done. 
- There's a lot of data copying and looking up in potentially large data structures (the ant router keeps a tab on 2000 UUID->host/port mappings). Lots of room for optimization.
- No thoughts yet on creating streaming connections between peers for when really large amounts of data need to be transfered (ideally, this is done with TCP but that won't work in a NAT/NAT situation. NAT/NAT needs testing too, anyway).
!
